import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DisableAlarmActionsInput } from "../models/models_0";
import { deserializeAws_queryDisableAlarmActionsCommand, serializeAws_queryDisableAlarmActionsCommand, } from "../protocols/Aws_query";
var DisableAlarmActionsCommand = (function (_super) {
    __extends(DisableAlarmActionsCommand, _super);
    function DisableAlarmActionsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DisableAlarmActionsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "DisableAlarmActionsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DisableAlarmActionsInput.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DisableAlarmActionsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDisableAlarmActionsCommand(input, context);
    };
    DisableAlarmActionsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDisableAlarmActionsCommand(output, context);
    };
    return DisableAlarmActionsCommand;
}($Command));
export { DisableAlarmActionsCommand };
