import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetMetricStreamInput, GetMetricStreamOutput } from "../models/models_0";
import { deserializeAws_queryGetMetricStreamCommand, serializeAws_queryGetMetricStreamCommand, } from "../protocols/Aws_query";
var GetMetricStreamCommand = (function (_super) {
    __extends(GetMetricStreamCommand, _super);
    function GetMetricStreamCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetMetricStreamCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "GetMetricStreamCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetMetricStreamInput.filterSensitiveLog,
            outputFilterSensitiveLog: GetMetricStreamOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetMetricStreamCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetMetricStreamCommand(input, context);
    };
    GetMetricStreamCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetMetricStreamCommand(output, context);
    };
    return GetMetricStreamCommand;
}($Command));
export { GetMetricStreamCommand };
