import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetMetricWidgetImageInput, GetMetricWidgetImageOutput } from "../models/models_0";
import { deserializeAws_queryGetMetricWidgetImageCommand, serializeAws_queryGetMetricWidgetImageCommand, } from "../protocols/Aws_query";
var GetMetricWidgetImageCommand = (function (_super) {
    __extends(GetMetricWidgetImageCommand, _super);
    function GetMetricWidgetImageCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetMetricWidgetImageCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "GetMetricWidgetImageCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetMetricWidgetImageInput.filterSensitiveLog,
            outputFilterSensitiveLog: GetMetricWidgetImageOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetMetricWidgetImageCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryGetMetricWidgetImageCommand(input, context);
    };
    GetMetricWidgetImageCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryGetMetricWidgetImageCommand(output, context);
    };
    return GetMetricWidgetImageCommand;
}($Command));
export { GetMetricWidgetImageCommand };
