import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListMetricsInput, ListMetricsOutput } from "../models/models_0";
import { deserializeAws_queryListMetricsCommand, serializeAws_queryListMetricsCommand } from "../protocols/Aws_query";
var ListMetricsCommand = (function (_super) {
    __extends(ListMetricsCommand, _super);
    function ListMetricsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListMetricsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "ListMetricsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListMetricsInput.filterSensitiveLog,
            outputFilterSensitiveLog: ListMetricsOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListMetricsCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryListMetricsCommand(input, context);
    };
    ListMetricsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryListMetricsCommand(output, context);
    };
    return ListMetricsCommand;
}($Command));
export { ListMetricsCommand };
