import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PutDashboardInput, PutDashboardOutput } from "../models/models_0";
import { deserializeAws_queryPutDashboardCommand, serializeAws_queryPutDashboardCommand } from "../protocols/Aws_query";
var PutDashboardCommand = (function (_super) {
    __extends(PutDashboardCommand, _super);
    function PutDashboardCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PutDashboardCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudWatchClient";
        var commandName = "PutDashboardCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PutDashboardInput.filterSensitiveLog,
            outputFilterSensitiveLog: PutDashboardOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PutDashboardCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryPutDashboardCommand(input, context);
    };
    PutDashboardCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryPutDashboardCommand(output, context);
    };
    return PutDashboardCommand;
}($Command));
export { PutDashboardCommand };
