import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudWatchClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudWatchClient";
import { PutMetricDataInput } from "../models/models_0";
export interface PutMetricDataCommandInput extends PutMetricDataInput {
}
export interface PutMetricDataCommandOutput extends __MetadataBearer {
}

export declare class PutMetricDataCommand extends $Command<PutMetricDataCommandInput, PutMetricDataCommandOutput, CloudWatchClientResolvedConfig> {
    readonly input: PutMetricDataCommandInput;
    constructor(input: PutMetricDataCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudWatchClientResolvedConfig, options?: __HttpHandlerOptions): Handler<PutMetricDataCommandInput, PutMetricDataCommandOutput>;
    private serialize;
    private deserialize;
}
