/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __awaiter } from "tslib";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
/**
 * This sample demonstrates how to Creates or updates an unlocked immutability policy. ETag in If-Match is honored if given but not required for this operation.
 *
 * @summary Creates or updates an unlocked immutability policy. ETag in If-Match is honored if given but not required for this operation.
 * x-ms-original-file: specification/storage/resource-manager/Microsoft.Storage/stable/2021-08-01/examples/BlobContainersPutImmutabilityPolicyAllowProtectedAppendWritesAll.json
 */
import { StorageManagementClient } from "@azure/arm-storage";
import { DefaultAzureCredential } from "@azure/identity";
function createOrUpdateImmutabilityPolicyWithAllowProtectedAppendWritesAll() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = "{subscription-id}";
        const resourceGroupName = "res1782";
        const accountName = "sto7069";
        const containerName = "container6397";
        const parameters = {
            allowProtectedAppendWritesAll: true,
            immutabilityPeriodSinceCreationInDays: 3
        };
        const options = { parameters: parameters };
        const credential = new DefaultAzureCredential();
        const client = new StorageManagementClient(credential, subscriptionId);
        const result = yield client.blobContainers.createOrUpdateImmutabilityPolicy(resourceGroupName, accountName, containerName, options);
        console.log(result);
    });
}
createOrUpdateImmutabilityPolicyWithAllowProtectedAppendWritesAll().catch(console.error);
//# sourceMappingURL=createOrUpdateImmutabilityPolicyWithAllowProtectedAppendWritesAll.js.map