import * as coreClient from "@azure/core-client";
import * as coreAuth from "@azure/core-auth";
import { Operations, Skus, StorageAccounts, DeletedAccounts, Usages, ManagementPolicies, BlobInventoryPolicies, PrivateEndpointConnections, PrivateLinkResources, ObjectReplicationPoliciesOperations, LocalUsersOperations, EncryptionScopes, BlobServices, BlobContainers, FileServices, FileShares, QueueServices, Queue, TableServices, TableOperations } from "./operationsInterfaces";
import { StorageManagementClientOptionalParams } from "./models";
export declare class StorageManagementClient extends coreClient.ServiceClient {
    $host: string;
    apiVersion: string;
    subscriptionId: string;
    /**
     * Initializes a new instance of the StorageManagementClient class.
     * @param credentials Subscription credentials which uniquely identify client subscription.
     * @param subscriptionId The ID of the target subscription.
     * @param options The parameter options
     */
    constructor(credentials: coreAuth.TokenCredential, subscriptionId: string, options?: StorageManagementClientOptionalParams);
    operations: Operations;
    skus: Skus;
    storageAccounts: StorageAccounts;
    deletedAccounts: DeletedAccounts;
    usages: Usages;
    managementPolicies: ManagementPolicies;
    blobInventoryPolicies: BlobInventoryPolicies;
    privateEndpointConnections: PrivateEndpointConnections;
    privateLinkResources: PrivateLinkResources;
    objectReplicationPoliciesOperations: ObjectReplicationPoliciesOperations;
    localUsersOperations: LocalUsersOperations;
    encryptionScopes: EncryptionScopes;
    blobServices: BlobServices;
    blobContainers: BlobContainers;
    fileServices: FileServices;
    fileShares: FileShares;
    queueServices: QueueServices;
    queue: Queue;
    tableServices: TableServices;
    tableOperations: TableOperations;
}
//# sourceMappingURL=storageManagementClient.d.ts.map