/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __awaiter } from "tslib";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
import { SubscriptionClient } from "@azure/arm-subscriptions";
import { DefaultAzureCredential } from "@azure/identity";
/**
 * This sample demonstrates how to Accept subscription ownership.
 *
 * @summary Accept subscription ownership.
 * x-ms-original-file: specification/subscription/resource-manager/Microsoft.Subscription/stable/2021-10-01/examples/acceptSubscriptionOwnership.json
 */
function acceptOwnership() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = "291bba3f-e0a5-47bc-a099-3bdcb2a50a05";
        const body = {
            properties: {
                displayName: "Test Subscription",
                managementGroupId: undefined,
                tags: { tag1: "Messi", tag2: "Ronaldo", tag3: "Lebron" }
            }
        };
        const credential = new DefaultAzureCredential();
        const client = new SubscriptionClient(credential);
        const result = yield client.subscriptionOperations.beginAcceptOwnershipAndWait(subscriptionId, body);
        console.log(result);
    });
}
acceptOwnership().catch(console.error);
//# sourceMappingURL=subscriptionAcceptOwnershipSample.js.map